//
// LinkDef.h for ginac dictionary

/*
 *  gTybalt Copyright (C) 2001 Stefan Weinzierl and Roberta Marani
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

// Root v3.03.06: "defined_in" generates shadow classes

// Root version 6 and higher: directives for global variables and functions are ignored

// options for classes:
// "-" : tells rootcling not to generate the Streamer method for this class
// "!" : tells rootcling not to generate the operator>>(TBuffer &b, MyClass *&obj) method for this class
// "+" : tells rootcling in root version 3 or later to use the new I/O system  

//#pragma link off all class;

#pragma link C++ nestedclass;
#pragma link C++ nestedtypedef;

// -----------------------------------------
// GiNaC

// list namespace cln here, to get class numeric to work
#pragma link C++ namespace cln;
#pragma link C++ namespace GiNaC;

// fine tuning: select classes individually
#pragma link C++ class GiNaC::ex-!;
#pragma link C++ class GiNaC::basic-!;

// container.h
#pragma link C++ class GiNaC::container-!;

#pragma link C++ class GiNaC::symbol-!;
#pragma link C++ class GiNaC::constant-!;
#pragma link C++ class GiNaC::numeric-!;
#pragma link C++ class GiNaC::wildcard-!;
#pragma link C++ class GiNaC::matrix-!;

#pragma link C++ class GiNaC::add-!;
#pragma link C++ class GiNaC::mul-!;
#pragma link C++ class GiNaC::ncmul-!;
#pragma link C++ class GiNaC::power-!;

#pragma link C++ class GiNaC::lst-!;
#pragma link C++ class GiNaC::pseries-!;

#pragma link C++ class GiNaC::function-!;
#pragma link C++ class GiNaC::fderivative-!;
#pragma link C++ class GiNaC::function_options-!;

#pragma link C++ class GiNaC::idx-!;
#pragma link C++ class GiNaC::varidx-!;

#pragma link C++ class GiNaC::indexed-!;
#pragma link C++ class GiNaC::scalar_products-!;

// tensor.h
#pragma link C++ class GiNaC::tensor-!;
#pragma link C++ class GiNaC::tensdelta-!;
#pragma link C++ class GiNaC::tensmetric-!;
#pragma link C++ class GiNaC::minkmetric-!;
#pragma link C++ class GiNaC::spinmetric-!;
#pragma link C++ class GiNaC::tensepsilon-!;

// clifford.h
#pragma link C++ class GiNaC::clifford-!;
#pragma link C++ class GiNaC::diracone-!;
#pragma link C++ class GiNaC::diracgamma-!;
#pragma link C++ class GiNaC::diracgamma5-!;

// color.h
#pragma link C++ class GiNaC::color-!;
#pragma link C++ class GiNaC::su3one-!;
#pragma link C++ class GiNaC::su3t-!;
#pragma link C++ class GiNaC::su3f-!;
#pragma link C++ class GiNaC::su3d-!;

// print.h
#pragma link C++ class GiNaC::print_context-!;
#pragma link C++ class GiNaC::print_latex-!;
#pragma link C++ class GiNaC::print_python-!;
#pragma link C++ class GiNaC::print_python_repr-!;
#pragma link C++ class GiNaC::print_tree-!;
#pragma link C++ class GiNaC::print_csrc-!;
#pragma link C++ class GiNaC::print_csrc_float-!;
#pragma link C++ class GiNaC::print_csrc_double-!;
#pragma link C++ class GiNaC::print_csrc_cl_N-!;

// flags.h
#pragma link C++ class GiNaC::domain-!;
#pragma link C++ class GiNaC::expand_options-!;
#pragma link C++ class GiNaC::series_options-!;
#pragma link C++ class GiNaC::determinant_algo-!;
#pragma link C++ class GiNaC::solve_algo-!;
#pragma link C++ class GiNaC::status_flags-!;
#pragma link C++ class GiNaC::info_flags-!;
#pragma link C++ class GiNaC::return_types-!;
#pragma link C++ class GiNaC::remember_strategies-!;

// archive.h
#pragma link C++ class GiNaC::archive-!;
#pragma link C++ class GiNaC::archive_node-!;

// relational.h
#pragma link C++ class GiNaC::relational-!;

/*
// expair.h
#pragma link C++ class GiNaC::expair-!;
#pragma link C++ class GiNaC::expair_is_less-!;
// expairseq.h
#pragma link C++ class GiNaC::expairseq-!;
// exprseq.h
#pragma link C++ class GiNaC::exprseq-!;
// fail.h
#pragma link C++ class GiNaC::fail-!;
// structure.h
#pragma link C++ class GiNaC::structure-!;
*/

// factor.h
//#pragma link C++ function GiNaC::factor(const GiNaC::ex&, unsigned);

// integration_kernel.h
#pragma link C++ class GiNaC::integration_kernel-!;
#pragma link C++ class GiNaC::basic_log_kernel-!;
#pragma link C++ class GiNaC::multiple_polylog_kernel-!;
#pragma link C++ class GiNaC::ELi_kernel-!;
#pragma link C++ class GiNaC::Ebar_kernel-!;
#pragma link C++ class GiNaC::Kronecker_dtau_kernel-!;
#pragma link C++ class GiNaC::Kronecker_dz_kernel-!;
#pragma link C++ class GiNaC::Eisenstein_kernel-!;
#pragma link C++ class GiNaC::Eisenstein_h_kernel-!;
#pragma link C++ class GiNaC::modular_form_kernel-!;
#pragma link C++ class GiNaC::user_defined_kernel-!;

// -----------------------------------------
// nestedsums
#ifdef HAVE_NESTEDSUMS

#pragma link C++ namespace nestedsums;

#pragma link C++ class nestedsums::root_of_unity-!;

#pragma link C++ class nestedsums::basic_letter-!;
#pragma link C++ class nestedsums::letter-!;
#pragma link C++ class nestedsums::unit_letter-!;

#pragma link C++ class nestedsums::Zsum-!;
#pragma link C++ class nestedsums::multiple_polylog-!;
#pragma link C++ class nestedsums::harmonic_polylog-!;
#pragma link C++ class nestedsums::nielsen_polylog-!;
#pragma link C++ class nestedsums::classical_polylog-!;
#pragma link C++ class nestedsums::Euler_Zagier_sum-!;
#pragma link C++ class nestedsums::multiple_zeta_value-!;

#pragma link C++ class nestedsums::Ssum-!;
#pragma link C++ class nestedsums::Ssum_to_Infinity-!;
#pragma link C++ class nestedsums::harmonic_sum-!;
#pragma link C++ class nestedsums::harmonic_sum_to_Infinity-!;

#pragma link C++ class nestedsums::Bsum-!;
#pragma link C++ class nestedsums::Csum-!;

#pragma link C++ class nestedsums::ratio_of_tgamma-!;
#pragma link C++ class nestedsums::list_of_tgamma-!;

#pragma link C++ class nestedsums::transcendental_sum_type_A-!;
#pragma link C++ class nestedsums::transcendental_sum_type_B-!;
#pragma link C++ class nestedsums::transcendental_sum_type_C-!;
#pragma link C++ class nestedsums::transcendental_sum_type_D-!;

#pragma link C++ class nestedsums::transcendental_fct_type_A-!;
#pragma link C++ class nestedsums::transcendental_fct_type_B-!;
#pragma link C++ class nestedsums::transcendental_fct_type_C-!;
#pragma link C++ class nestedsums::transcendental_fct_type_D-!;

#pragma link C++ class nestedsums::hash_entry-!;
#pragma link C++ class nestedsums::expand_status-!;
#pragma link C++ class nestedsums::nestedsums_status_flags-!;

/*
#pragma link C++ function nestedsums::Harmonic_sum(GiNaC::ex,GiNaC::ex);
#pragma link C++ function nestedsums::EulerZagier_sum(GiNaC::ex,GiNaC::ex);
#pragma link C++ function nestedsums::S_sum_infinity(GiNaC::ex,GiNaC::ex);
#pragma link C++ function nestedsums::S_sum(GiNaC::ex,GiNaC::ex,GiNaC::ex);
#pragma link C++ function nestedsums::Z_sum(GiNaC::ex,GiNaC::ex,GiNaC::ex);
*/

#endif

// -----------------------------------------
// stuff defined in routines.h

// functions
#pragma link C++ function greeting;
#pragma link C++ function warranty;
#pragma link C++ function credits;

#pragma link C++ function print;
#pragma link C++ function prettyprint;
#pragma link C++ function rawprint;
#pragma link C++ function plot;
#pragma link C++ function intnum;

// global objects
#pragma link C++ global gTybalt_int_res;
#pragma link C++ global gTybalt_int_err;
#pragma link C++ global gTybalt_int_chi2;

#pragma link C++ global gTybalt_int_iter_low;
#pragma link C++ global gTybalt_int_iter_high;
#pragma link C++ global gTybalt_int_calls_low;
#pragma link C++ global gTybalt_int_calls_high;

// -----------------------------------------
// stuff defined in convenience.h
//
// (convenience.h provides only functions, but no classes)

#pragma link C++ defined_in "../gtybalt-lib/convenience.h";


